/* --------------------------------------------------------------------------
 * BreakOutInvaders
 * --------------------------------------------------------------------------
 * prog:  Giacomo Pedemonte
 * date:  28/09/2012 (d/m/y)
 * ----------------------------------------------------------------------------
 * Free mp3-Sounds from http://www.findsounds.com
 */

import ddf.minim.*;

Minim minim;
AudioSample ballHitSnd;
AudioSample ballHitSchlaegerSnd;
AudioSample shootBallSnd;

// BouncingBall[] ball = null;
Racket         schlaeger = null;
Brick[]        brickList = null;

ArrayList<BouncingBall> baelle = new ArrayList<BouncingBall>();

final static int GAME_MODE_MENU      = 0;
final static int GAME_MODE_PLAY      = 1;
final static int GAME_MODE_GAMEOVER  = 2;

int          gameMode = GAME_MODE_MENU;
int          invNr;
int          invKlld = 0;
int          score = 0;
int          rdmball;
float        millisSaved = -2000;
PImage       bg;


void setup()
{
  size(800, 600);
  
  bg = loadImage("background.jpg");

  schlaeger = new Racket(0, height - 40, 75, 25);   

  // sound init
  minim = new Minim(this);
  ballHitSnd = minim.loadSample("hit.mp3");
  ballHitSchlaegerSnd = minim.loadSample("hitSchlaeger.mp3");
  shootBallSnd = minim.loadSample("LaserGun.mp3");

  smooth(); 
  noCursor();
}

void initGameScene()
{
//  invNr = (int)random(3, 12);
  invNr = 10;
  // erzeuge die ziegel
  brickList = new Brick[invNr];
  for (int i=0;i < invNr;i++)
  {
//    rdmball = (int)(random(0,1)+.5);
//    if(rdmball == 1) {
      brickList[i] = new Brick(105 + i * 65, (int)random(0, 150), 60, 30);
//    }
  }
}


void draw()
{
  // ghosting
  fill(0, 0, 0, 100);
  background(bg);
  rect(0, 0, width, height);



  drawScene();
}

void drawScene()
{
  switch(gameMode)
  {
  case GAME_MODE_MENU:
    drawMenu();
    break;
  case GAME_MODE_PLAY:
    drawGame();
    break;  
  case GAME_MODE_GAMEOVER:
    drawGameOver();
    break;
  }
}

void drawMenu()
{
  pushStyle();
  fill(#2BEAFA);
  textSize(14);
  text("BreakOut-Invaders", 350, 200);  

  text("\'p\' : start game", 350, 230);  
  text("Space : stop game", 350, 250);   
  popStyle();
}

void drawGameOver()
{
  pushStyle();
    fill(#2BEAFA);
    textSize(14);
    text("Game Over\n\nScore: " + score, 350, 200);  
  popStyle();
}

void drawGame()
{
  // update die daten, berechne kollisionen
  updateScene();
  
  pushStyle();
    fill(#2BEAFA);
    textSize(14);
    text("Score: " + score,20,20);
  popStyle();
  
  // zeichne ziegel
  for (int i=0;i < invNr;i++)
  {
    if (brickList[i] != null)
      brickList[i].draw();
  }

  // zeichne den ball
  for (int i=0;i < baelle.size() ;i++)
  {
    baelle.get(i).draw();
  }

  // zeichne schlaeger
  schlaeger.draw();
}

void keyPressed()
{
  switch(key)
  {
  case 'p':
    // start game
    invKlld = 0;
    score = 0;
    gameMode = GAME_MODE_PLAY;
    initGameScene();
    break;
  case ' ':
    // end
    gameMode = GAME_MODE_MENU;
    break;
  }
}

void  updateScene()
{
  
  // erstelle Baelle nach 2 sek
  if(millis() - millisSaved >= 2000) {
    
    println("PEW");
    for (int i=0;i < brickList.length;i++) {
      rdmball = (int)(random(0,1)+.5);
      if(brickList[i] != null&& rdmball == 1) {
        shootBallSnd.trigger();
        BouncingBall tempball = new BouncingBall((int)brickList[i]._pos.x, (int)brickList[i]._pos.y+30, 5);
        tempball.set(new PVector((int)brickList[i]._pos.x, (int)brickList[i]._pos.y+30), new PVector(0, 5), 1);

        baelle.add(tempball);
      } 
    }
    millisSaved = millis();
  }

  // update schlaeger pos
  schlaeger.move(mouseX, mouseY);
  
  PVector hitPos = new PVector();
  for(BouncingBall ball : baelle)
  {
    // teste ob ball den schlaeger trifft
    int retVal = schlaeger.checkCollision(ball._pos.x, ball._pos.y, ball._r, ball._dir,hitPos);
    switch(retVal)
    {
    case Brick.HIT_LEFT:
    case Brick.HIT_RIGTH:
      // aendere flugrichtung ball    
      ball._dir.x *= -1;
      
      // spiele sound
      ballHitSchlaegerSnd.trigger();
      break;
    case Brick.HIT_TOP:
    case Brick.HIT_BOTTOM:
      // aendere flugrichtung ball
      
      // anschnitt berechnen 
      float hitV = hitPos.x - (schlaeger._pos.x - schlaeger._w/2);
      hitV = 1.0 / schlaeger._w * hitV - 0.5;
      
      ball._dir.x += hitV * 8; 
      ball._dir.y *= -1;
      
      // ball soll die gleiche geschwindigkeit haben wie am anfang
      float speed = ball._dir.mag();
      ball._dir.normalize();
      ball._dir.mult(speed);
     
      // setzte ball buendig auf den schlaeger(das er nicht im schlaeger ist)
      ball._pos.y = schlaeger._pos.y - schlaeger._h/2 -1 ;
  
      // spiele sound
      ballHitSchlaegerSnd.trigger();
      break;
    }
    
    // test ob ball einen ziegel trifft
    for (int i=0;i < invNr;i++)
    {
      if (brickList[i] != null)
      {
        // test ob ziegel aus dem spielfeld ist
        if (brickList[i]._pos.y > height)
        {
          gameMode = GAME_MODE_GAMEOVER;
          return;
        }
        
        retVal = brickList[i].checkCollision(ball._pos.x, ball._pos.y, ball._r, ball._dir,hitPos);
        switch(retVal)
        {
        case Brick.HIT_LEFT:
        case Brick.HIT_RIGTH:
          // aendere flugrichtung ball
          ball._dir.x *= -1;
          invKlld++;
          score++;
  
          // entferne ziegel aus liste
          brickList[i] = null;
          
          // spiele sound
          ballHitSnd.trigger();
          break;
        case Brick.HIT_TOP:
        case Brick.HIT_BOTTOM:
          // aendere flugrichtung ball
          ball._dir.y *= -1;
          invKlld++;
          score++;
  
          // entferne ziegel aus liste
          brickList[i] = null;
  
          // spiele sound
          ballHitSnd.trigger();
          break;
        }
      }
    }
    // Nein? Mehr Invaders!!
    if(invKlld >= invNr){
      invKlld = 0;
      gameMode = GAME_MODE_PLAY;
      initGameScene();
    }
  }

}


