/* --------------------------------------------------------------------------
 * BreakOutInvaders
 * --------------------------------------------------------------------------
 * prog:  Giacomo Pedemonte
 * date:  28/09/2012 (d/m/y)
 * ----------------------------------------------------------------------------
 * Free mp3-Sounds from http://www.findsounds.com
 */

class Brick
{
  final static int  HIT_NO     = 0;
  final static int  HIT_LEFT   = 1;
  final static int  HIT_RIGTH  = 2;
  final static int  HIT_TOP    = 3;
  final static int  HIT_BOTTOM = 4;

  PVector   _pos;
  float     _w;
  float     _h;
  float     _acc;
  PImage    _invPng;
  

  // konstruktor
  Brick(int x, int y, int w, int h)
  {
    _pos = new PVector(x, y);

    _w = w;
    _h = h;
    
    _invPng = loadImage("ship.png");
  }

  // zeichnet den brick
  void draw()
  {
    pushStyle();
    rectMode(CENTER);
    imageMode(CENTER);
    fill(255);
    image(_invPng, _pos.x, _pos.y, _w, _h);
//    rect(_pos.x, _pos.y, _w, _h);
    popStyle();
    _pos.y = _pos.y + 0.5;
  }

  PVector cornerLT()
  {
    return new PVector(_pos.x - _w / 2, _pos.y - _h / 2);
  }

  PVector cornerRT()
  {
    return new PVector(_pos.x + _w / 2, _pos.y - _h / 2);
  }

  PVector cornerLB()  
  {
    return new PVector(_pos.x - _w / 2, _pos.y + _h / 2);
  }

  PVector cornerRB()
  {
    return new PVector(_pos.x + _w / 2, _pos.y + _h / 2);
  }

  int checkCollision(float x, float y, float r, PVector dirObj,PVector hitPos)
  {
    if(x + r >= _pos.x - _w/2  && x -r <= _pos.x + _w/2 &&
       y + r >= _pos.y - _h/2 && y - r <= _pos.y + _h/2)
    {
      // teste welche kannte getroffen wurde
      PVector dir = dirObj.get();
      dir.normalize();   
      
      // berechne eine linie 
      PVector pObj = new PVector(x, y);
      PVector pObjPrev = PVector.sub(pObj, PVector.mult(dir, 100));

      PVector lt = cornerLT();
      PVector rt = cornerRT();
      PVector lb = cornerLB();
      PVector rb = cornerRB();

      PVector vecTop     = lineIntersection(pObjPrev.x, pObjPrev.y, pObj.x, pObj.y, 
                                             lt.x, lt.y, rt.x, rt.y);
      PVector vecBottom  = lineIntersection(pObjPrev.x, pObjPrev.y, pObj.x, pObj.y, 
                                            lb.x, lb.y, rb.x, rb.y);
      PVector vecLeft    = lineIntersection(pObjPrev.x, pObjPrev.y, pObj.x, pObj.y, 
                                             lt.x, lt.y, lb.x, lb.y);
      PVector vecRight   = lineIntersection(pObjPrev.x, pObjPrev.y, pObj.x, pObj.y, 
                                            rt.x, rt.y, rb.x, rb.y);
      
      // teste kante oben
      if(vecTop != null)
      {
        hitPos.set(vecTop);
        return HIT_TOP;
      }                
      else if(vecBottom != null)
      {
        hitPos.set(vecBottom);
        return HIT_BOTTOM;
      }                      
      else if (vecLeft != null)
      {
        hitPos.set(vecLeft);
        return HIT_LEFT;
      }                      
      else if (vecRight != null)
      {
        hitPos.set(vecRight);
        return HIT_RIGTH;
      }                      
      else
        return HIT_NO;

    }
    return HIT_NO;
  }
  
  
}

// checkout http://wiki.processing.org/w/Line-Line_intersection
PVector lineIntersection(float x1, float y1, float x2, float y2, float x3, float y3, float x4, float y4)
{
  float bx = x2 - x1;
  float by = y2 - y1;
  float dx = x4 - x3;
  float dy = y4 - y3; 
  float b_dot_d_perp = bx*dy - by*dx;
  if (b_dot_d_perp == 0) {
    return null;
  }
  float cx = x3-x1; 
  float cy = y3-y1;
  float t = (cx*dy - cy*dx) / b_dot_d_perp; 

  return new PVector(x1+t*bx, y1+t*by);
}

